Bug 1139251 (CVE-2014-3614) - CVE-2014-3614 A specific sequence of packets can crash PowerDNS Recursor 3.6.0 remotely
Summary: CVE-2014-3614 A specific sequence of packets can crash PowerDNS Recursor 3.6....
Status: CLOSED ERRATA
Alias: CVE-2014-3614
Product: Fedora
Classification: Fedora
Component: pdns-recursor
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Morten Stevens
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords: Security
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-09-08 13:17 UTC by Morten Stevens
Modified: 2014-09-27 18:45 UTC (History)
5 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2014-09-19 09:59:08 UTC


Attachments (Terms of Use)

Description Morten Stevens 2014-09-08 13:17:00 UTC
Description of problem:

This very critical security issue affects all Fedora and Fedora-EPEL branches!

Today, I got this message directly from upstream project:

Gentlemen,

please read the notification below. Summary: 3.5.3 okay, 3.6.0 broken, 3.6.1 coming wednesday, please keep secret until then.

Cheers, Peter


---------

The contents of this email message are confidential until the 10th of
September 2014. 

Issue:		A specific sequence of packets can crash PowerDNS Recursor
		3.6.0 remotely
CVE:		CVE-2014-3614
Affected:     	All deployments of PowerDNS Recursor 3.6.0
Not Affected: 	PowerDNS Authoritative Server, PowerDNS Recursor versions
		other than 3.6.0
Workaround:	Only users from netmasks specified in 'allow-from' can
		cause the crash. 
Remediation:	Upgrade to the packages we provided, or apply our minimal
		patch and recompile

Recently, we've discovered that PowerDNS Recursor 3.6.0 (but NOT earlier)
can crash when exposed to a specific sequence of malformed packets.  This
sequence happened spontaneously with one of our largest deployments, and
the packets did not appear to have a malicious origin.

Yet, this crash can be triggered remotely, leading to a denial of service
attack. There appears to be no way to use this crash for system compromise
or stack overflow.

Fixed packages and sources are already available on:

* Tar https://autotest.powerdns.com/job/recursor-git/1400/artifact/pdns/pdns-recursor-git-unknown-20140902-1400-2203669.tar.bz2
* 64 bit RPM/DEB https://autotest.powerdns.com/job/recursor-git-semistatic-pkgs-amd64/1034/
* 32 bit RPM/DEB https://autotest.powerdns.com/job/recursor-git-semistatic-pkgs-i386/1034/

In addition, if you want to apply a minimal fix, it can be found on:
https://xs.powerdns.com/tmp/minipatch-3.6.1

We will release 3.6.1 on the 10th of Sepember 2014. In addition, two weeks
after that, we will give a fuller explanation on the causes of the crash.

If you need any help in upgrading your PowerDNS Recursor, or if you are a
PowerDNS distributor and have questions, please contact us on
powerdns.support@powerdns.com.

Finally a reminder - the contents of this message are confidential until the
10th of September!

	Bert

Comment 1 Morten Stevens 2014-09-08 13:24:56 UTC
Version-Release number of selected component (if applicable):

Fedora:

pdns-recursor-3.6.0-1.fc19
pdns-recursor-3.6.0-1.fc20
pdns-recursor-3.6.0-2.fc21
pdns-recursor-3.6.0-2.fc22

Fedora-EPEL:

pdns-recursor-3.6.0-1.el5
pdns-recursor-3.6.0-1.el6
pdns-recursor-3.6.0-1.el7

Comment 2 Vincent Danen 2014-09-08 16:49:54 UTC
Thanks for filing this.  I presume you will be submitting builds for the above after this has been made public?  Do you know if upstream has or requires a CVE for this?  We can provide one if they do not have one already.  If they do, can you please note it in the bug?

Comment 3 Morten Stevens 2014-09-08 19:59:55 UTC
(In reply to Vincent Danen from comment #2)
> Thanks for filing this.  I presume you will be submitting builds for the
> above after this has been made public?  Do you know if upstream has or
> requires a CVE for this?  We can provide one if they do not have one
> already.  If they do, can you please note it in the bug?

I've added Peter (peter.van.dijk@netherlabs.nl) to the cc list. He's upstream developer.

As already mentioned in my first comment, upstream has already requested a CVE number (CVE-2014-3614).

And yes, my plan is to build 3.6.1 packages for all Fedora and Fedora-EPEL branches until this has been made public.

Comment 4 Peter van Dijk (PowerDNS) 2014-09-09 10:42:28 UTC
https://autotest.powerdns.com/job/recursor-git/1412/artifact/pdns/pdns-recursor-3.6.1.tar.bz2 is ready. Announcement will happen tomorrow.

Comment 6 Vincent Danen 2014-09-10 14:30:44 UTC
This is now public:

https://www.powerdns.com/news.html#20141010

Comment 7 Fedora Update System 2014-09-10 14:32:57 UTC
pdns-recursor-3.6.1-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/pdns-recursor-3.6.1-1.fc19

Comment 8 Fedora Update System 2014-09-10 14:33:23 UTC
pdns-recursor-3.6.1-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/pdns-recursor-3.6.1-1.fc20

Comment 9 Fedora Update System 2014-09-10 14:33:29 UTC
pdns-recursor-3.6.1-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/pdns-recursor-3.6.1-1.fc21

Comment 10 Fedora Update System 2014-09-10 14:34:07 UTC
pdns-recursor-3.6.1-1.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/pdns-recursor-3.6.1-1.el5

Comment 11 Fedora Update System 2014-09-10 14:34:11 UTC
pdns-recursor-3.6.1-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/pdns-recursor-3.6.1-1.el6

Comment 12 Fedora Update System 2014-09-10 14:34:16 UTC
pdns-recursor-3.6.1-1.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/pdns-recursor-3.6.1-1.el7

Comment 13 Fedora Update System 2014-09-10 16:41:35 UTC
Package pdns-recursor-3.6.1-1.fc21:
* should fix your issue,
* was pushed to the Fedora 21 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing pdns-recursor-3.6.1-1.fc21'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2014-10600/pdns-recursor-3.6.1-1.fc21
then log in and leave karma (feedback).

Comment 14 Fedora Update System 2014-09-19 09:59:08 UTC
pdns-recursor-3.6.1-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 15 Fedora Update System 2014-09-19 10:14:46 UTC
pdns-recursor-3.6.1-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2014-09-23 04:22:31 UTC
pdns-recursor-3.6.1-1.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2014-09-26 17:00:31 UTC
pdns-recursor-3.6.1-1.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2014-09-26 17:01:10 UTC
pdns-recursor-3.6.1-1.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2014-09-27 18:45:31 UTC
pdns-recursor-3.6.1-1.el7 has been pushed to the Fedora EPEL 7 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.